# generated by datamodel-codegen:
#   filename:  tmptoll2762.json
#   timestamp: 2024-03-21T21:34:10+00:00

from __future__ import annotations

from dataclasses import dataclass
from typing import List, Optional, Union


@dataclass
class AccessTokenResponse:
    access_token: str
    token_type: str
    expires_in: Optional[int] = None
    refresh_token: Optional[str] = None
    scope: Optional[str] = None


@dataclass
class AnnularCylinder:
    height: Optional[float] = 0.0
    radius_outer: Optional[float] = 0.0
    radius_inner: Optional[float] = 0.0


@dataclass
class BilateralTolerance:
    value: Optional[float] = 0.0
    minus: Optional[float] = 0.0
    plus: Optional[float] = 0.0


@dataclass
class BodyTokenAuthTokenPost:
    grant_type: str
    client_id: Optional[str] = None
    client_secret: Optional[str] = None
    assertion: Optional[str] = None


@dataclass
class Bore:
    radius: Optional[BilateralTolerance] = None
    depth: Optional[float] = 0.0
    has_reamer: Optional[bool] = False


@dataclass
class Box:
    x: Optional[float] = 0.0
    y: Optional[float] = 0.0
    z: Optional[float] = 0.0


@dataclass
class Counterbore:
    radius: Optional[float] = 0.0
    depth: Optional[float] = 0.0


@dataclass
class Countersink:
    radius: Optional[float] = 0.0
    angle: Optional[float] = 0.0


@dataclass
class CutFace:
    radius: Optional[float] = 0.0
    area: Optional[float] = 0.0
    depth: Optional[float] = 0.0


@dataclass
class Cylinder:
    radius: Optional[float] = 0.0
    height: Optional[float] = 0.0


@dataclass
class Error:
    code: Optional[str] = ''
    message: Optional[str] = ''


@dataclass
class FileBlob:
    file_id: Optional[str] = ''
    name: Optional[str] = ''
    data: Optional[bytes] = ''
    url: Optional[str] = ''
    mediatype: Optional[str] = ''
    sha256: Optional[str] = ''


@dataclass
class FlatSettings:
    undersize_holes: Optional[float] = 0.0


@dataclass
class GeometrySummary:
    geom_id: Optional[str] = ''
    node_id: Optional[List[str]] = None
    name: Optional[str] = ''
    preview: Optional[FileBlob] = None


@dataclass
class Interval:
    min: Optional[float] = 0.0
    max: Optional[float] = 0.0


@dataclass
class JobCreation:
    task_id: str


@dataclass
class JobStatus:
    progress: float
    code: str
    message: str


@dataclass
class KFactor:
    material_id: Optional[str] = ''
    radius_fraction: Optional[List[float]] = None
    k_factor: Optional[List[float]] = None


@dataclass
class ManualFabrication:
    pass


@dataclass
class Mesh:
    blob: Optional[FileBlob] = None


@dataclass
class MillMachine:
    tool_pad: Optional[float] = 0.0
    spindle_length: Optional[float] = 0.0
    spindle_radius: Optional[float] = 0.0
    spindle_pad: Optional[float] = 0.0
    max_z_travel: Optional[float] = 0.0
    extents: Optional[List[float]] = None
    feed_max: Optional[float] = 0.0
    rpm_max: Optional[float] = 0.0


@dataclass
class Money:
    currency: Optional[str] = ''
    amount: Optional[float] = 0.0


@dataclass
class NDArray:
    shape: Optional[List[int]] = None
    float64: Optional[List[float]] = None
    int64: Optional[List[int]] = None


@dataclass
class Outcome:
    is_completed: Optional[bool] = False
    is_success: Optional[bool] = False
    errors: Optional[List[Error]] = None
    quality: Optional[float] = 0.0
    duration: Optional[float] = 0.0


@dataclass
class PartConfiguration:
    method_id: Optional[str] = ''
    quantity: Optional[int] = 0
    material_id: Optional[str] = ''
    finish_id: Optional[str] = ''
    color_id: Optional[str] = ''
    thickness_id: Optional[str] = ''
    posts: Optional[List[str]] = None
    expedite: Optional[str] = ''
    notes: Optional[str] = ''
    cots_id: Optional[str] = ''


@dataclass
class Plane:
    origin: Optional[List[float]] = None
    normal: Optional[List[float]] = None
    area: Optional[float] = 0.0
    height: Optional[float] = 0.0
    extents: Optional[List[float]] = None
    volume: Optional[float] = 0.0
    volume_support: Optional[float] = 0.0


@dataclass
class Point3D:
    x: Optional[float] = 0.0
    y: Optional[float] = 0.0
    z: Optional[float] = 0.0


@dataclass
class PostalAddress:
    address_id: Optional[str] = ''
    country: Optional[str] = ''
    region: Optional[str] = ''
    city: Optional[str] = ''
    postal_code: Optional[str] = ''
    address_lines: Optional[List[str]] = None
    recipient: Optional[str] = ''
    phone: Optional[str] = ''
    email: Optional[str] = ''
    latitude: Optional[float] = 0.0
    longitude: Optional[float] = 0.0
    place_id: Optional[str] = ''


@dataclass
class RigidTransform:
    values: Optional[List[float]] = None


@dataclass
class Scene:
    neutral: Optional[FileBlob] = None
    name: Optional[str] = ''
    geometries: Optional[List[GeometrySummary]] = None
    preview: Optional[FileBlob] = None


@dataclass
class Segment:
    start: Optional[Point3D] = None
    final: Optional[Point3D] = None
    angle: Optional[float] = 0.0
    tag: Optional[int] = 0
    tool_index: Optional[int] = 0
    radius_override: Optional[float] = 0.0


@dataclass
class SegmentStatistics:
    length: Optional[float] = 0.0
    duration: Optional[float] = 0.0
    tool_length: Optional[List[float]] = None
    tool_duration: Optional[List[float]] = None
    tool_changes: Optional[int] = 0


@dataclass
class Thread:
    is_imperial: Optional[bool] = False
    description: Optional[str] = ''
    pitch: Optional[float] = 0.0
    radius_minor: Optional[float] = 0.0
    radius_major: Optional[float] = 0.0


@dataclass
class Timestamp:
    seconds: Optional[float] = 0.0


@dataclass
class ToolParameters:
    material_id: Optional[str] = ''
    surface_feet_per_minute: Optional[Interval] = None
    inch_per_tooth: Optional[Interval] = None
    maximum_rpm: Optional[float] = 0.0
    radial_depth_of_cut: Optional[float] = 0.0
    is_carbide: Optional[bool] = False
    flutes: Optional[int] = 0
    use_rough: Optional[bool] = False
    use_finish: Optional[bool] = False


@dataclass
class TurnFabrication:
    height: Optional[float] = 0.0
    diameter: Optional[float] = 0.0
    volume: Optional[float] = 0.0
    inner_diameter: Optional[float] = 0.0
    profile: Optional[FileBlob] = None


@dataclass
class UploadRequest:
    filename: str


@dataclass
class UploadResponse:
    file_id: str
    upload_url: str
    expiration: str


@dataclass
class ValidationError:
    loc: List[Union[str, int]]
    msg: str
    type: str


@dataclass
class Weld:
    length: Optional[float] = 0.0


@dataclass
class AddFabrication:
    planes: Optional[List[Plane]] = None


@dataclass
class BendSettings:
    k_factor: Optional[List[KFactor]] = None


@dataclass
class BentRegions:
    wkt: Optional[str] = ''
    to_3d: Optional[NDArray] = None


@dataclass
class BoundingBox3D:
    lower: Optional[Point3D] = None
    upper: Optional[Point3D] = None


@dataclass
class Brand:
    brand_id: Optional[str] = ''
    name: Optional[str] = ''
    description: Optional[str] = ''
    logo: Optional[FileBlob] = None
    address: Optional[PostalAddress] = None
    display_units: Optional[str] = ''


@dataclass
class CotsMatch:
    cots_id: Optional[str] = ''
    supplier_id: Optional[str] = ''
    link: Optional[str] = ''
    title: Optional[str] = ''
    pack_price: Optional[Money] = None
    pack_size: Optional[int] = 0
    weight_lb: Optional[float] = 0.0
    component_id: Optional[str] = ''


@dataclass
class CutDrill:
    radius: Optional[float] = 0.0
    depth: Optional[List[float]] = None
    origins: Optional[NDArray] = None
    normal: Optional[List[float]] = None
    thru: Optional[bool] = False
    labels: Optional[List[str]] = None


@dataclass
class FlatFabrication:
    perimeter: Optional[float] = 0.0
    holes: Optional[List[float]] = None
    extents: Optional[List[float]] = None
    area: Optional[float] = 0.0
    rapids: Optional[float] = 0.0
    thickness: Optional[float] = 0.0
    flattened: Optional[FileBlob] = None
    to_flattened: Optional[RigidTransform] = None


@dataclass
class Geometry:
    box: Optional[Box] = None
    cylinder: Optional[Cylinder] = None
    annular: Optional[AnnularCylinder] = None
    mesh: Optional[Mesh] = None
    transform: Optional[RigidTransform] = None


@dataclass
class HTTPValidationError:
    detail: Optional[List[ValidationError]] = None


@dataclass
class Postprocess:
    post_id: Optional[str] = ''
    geom_id: Optional[str] = ''
    method_id: Optional[str] = ''
    kind: Optional[int] = 0
    group: Optional[str] = ''
    description: Optional[str] = ''
    markers: Optional[NDArray] = None
    is_default: Optional[bool] = False
    thread: Optional[Thread] = None
    countersink: Optional[Countersink] = None
    counterbore: Optional[Counterbore] = None
    weld: Optional[Weld] = None
    bore: Optional[Bore] = None


@dataclass
class RollFabrication:
    height: Optional[float] = 0.0
    diameter: Optional[float] = 0.0
    flat: Optional[FlatFabrication] = None


@dataclass
class Stock:
    stock_id: Optional[str] = ''
    material_id: Optional[str] = ''
    supplier_id: Optional[str] = ''
    supplier_pn: Optional[str] = ''
    price: Optional[Money] = None
    expiry: Optional[Timestamp] = None
    quantity: Optional[int] = 0
    kind: Optional[int] = 0
    length: Optional[float] = 0.0
    width: Optional[float] = 0.0
    height: Optional[float] = 0.0
    units: Optional[int] = 0


@dataclass
class Tool:
    shape: Optional[int] = 0
    index: Optional[int] = 0
    parameters: Optional[List[ToolParameters]] = None
    radius: Optional[float] = 0.0
    length_cut: Optional[float] = 0.0
    length_total: Optional[float] = 0.0
    suppliers: Optional[List[CotsMatch]] = None
    speed_feed: Optional[float] = 0.0
    speed_rpm: Optional[float] = 0.0


@dataclass
class ToolPlane:
    transform: Optional[RigidTransform] = None
    limits: Optional[BoundingBox3D] = None
    levels: Optional[List[float]] = None


@dataclass
class BentFabrication:
    bend_count: Optional[int] = 0
    bend_setups: Optional[int] = 0
    bend_k: Optional[List[float]] = None
    bend_angle: Optional[List[float]] = None
    bend_radii: Optional[List[float]] = None
    flat: Optional[FlatFabrication] = None
    regions: Optional[BentRegions] = None


@dataclass
class CotsFabrication:
    matches: Optional[List[CotsMatch]] = None
    cylinder: Optional[Cylinder] = None
    annular: Optional[AnnularCylinder] = None


@dataclass
class CutMill:
    volume: Optional[float] = 0.0
    radius: Optional[float] = 0.0
    tool: Optional[Tool] = None


@dataclass
class Fixture:
    strategy: Optional[int] = 0
    collision: Optional[Geometry] = None
    normal: Optional[List[float]] = None


@dataclass
class MillPreprocess:
    directions: Optional[NDArray] = None
    stock: Optional[Stock] = None
    stock_geometry: Optional[Geometry] = None
    mesh: Optional[Geometry] = None
    drills: Optional[List[CutDrill]] = None
    collision: Optional[List[Geometry]] = None


@dataclass
class MillSettings:
    material_id: Optional[str] = ''
    machine: Optional[MillMachine] = None
    tools: Optional[List[Tool]] = None
    detail: Optional[int] = 0
    return_volume: Optional[bool] = False
    return_gcode: Optional[bool] = False
    return_plan: Optional[bool] = False
    skip_fixture_collisions: Optional[bool] = False
    default_radial_depth_of_cut: Optional[float] = 0.0
    default_skip_ball: Optional[bool] = False
    plane_normals: Optional[NDArray] = None
    max_directions: Optional[int] = 0
    skip_prune: Optional[bool] = False
    preprocess: Optional[MillPreprocess] = None


@dataclass
class SegmentPath:
    segments: Optional[List[Segment]] = None
    tools: Optional[List[Tool]] = None
    plane: Optional[ToolPlane] = None
    stats: Optional[SegmentStatistics] = None


@dataclass
class Cut:
    mill: Optional[CutMill] = None
    drill: Optional[CutDrill] = None
    face: Optional[CutFace] = None
    fixture_index: Optional[int] = 0
    label: Optional[str] = ''


@dataclass
class FabricationSettings:
    method_id: Optional[List[str]] = None
    mill: Optional[MillSettings] = None
    bent: Optional[BendSettings] = None
    flat: Optional[FlatSettings] = None


@dataclass
class GeometryRequest:
    source: Optional[FileBlob] = None
    source_units: Optional[str] = ''
    brand: Optional[Brand] = None
    settings: Optional[FabricationSettings] = None
    return_previews: Optional[bool] = False
    return_interference: Optional[bool] = False
    return_proprietary: Optional[bool] = False


@dataclass
class MillPlan:
    part: Optional[Geometry] = None
    stock: Optional[Geometry] = None
    paths: Optional[List[SegmentPath]] = None


@dataclass
class MillFabrication:
    stock: Optional[Stock] = None
    fixtures: Optional[List[Fixture]] = None
    cuts: Optional[List[Cut]] = None
    volume: Optional[FileBlob] = None
    gcode: Optional[List[FileBlob]] = None
    plan: Optional[MillPlan] = None
    pre: Optional[MillPreprocess] = None
    machine: Optional[MillMachine] = None


@dataclass
class PartFabrication:
    geom_id: Optional[str] = ''
    geom_name: Optional[str] = ''
    method_id: Optional[str] = ''
    outcome: Optional[Outcome] = None
    defaults: Optional[PartConfiguration] = None
    posts: Optional[List[Postprocess]] = None
    drawing: Optional[FileBlob] = None
    extents: Optional[List[float]] = None
    flat: Optional[FlatFabrication] = None
    bent: Optional[BentFabrication] = None
    roll: Optional[RollFabrication] = None
    mill: Optional[MillFabrication] = None
    cots: Optional[CotsFabrication] = None
    add: Optional[AddFabrication] = None
    turn: Optional[TurnFabrication] = None
    manual: Optional[ManualFabrication] = None


@dataclass
class GeometryResponse:
    outcome: Optional[Outcome] = None
    analysis: Optional[List[PartFabrication]] = None
    scene: Optional[Scene] = None
